%define anolis_release 1
%global pypi_name fairseq
%global pypi_version 0.12.2

Name:           python-%{pypi_name}
Version:        %{pypi_version}
Release:        %{anolis_release}%{?dist}
Summary:        Facebook AI Research Sequence-to-Sequence Toolkit

License:        MIT
URL:            https://github.com/facebookresearch/fairseq
Source0:        https://github.com/facebookresearch/fairseq/archive/refs/tags/v0.12.2.tar.gz#/fairseq-0.12.2.tar.gz

BuildRequires:  python3-devel pytest
BuildRequires:  python3dist(bitarray)
BuildRequires:  python3dist(cffi)
BuildRequires:  python3dist(cython)
BuildRequires:  python3dist(hydra-core) >= 1.0.7
BuildRequires:  python3dist(numpy)
BuildRequires:  python3dist(omegaconf)
BuildRequires:  python3dist(regex)
BuildRequires:  python3dist(sacrebleu) >= 1.4.12
BuildRequires:  python3dist(setuptools) >= 18
BuildRequires:  python3dist(torch)
BuildRequires:  python3dist(torchaudio) >= 0.8
BuildRequires:  python3dist(tqdm)
BuildRequires:  python3dist(tensorboardx)
BuildRequires:  pytorch-devel

%description
Fairseq is a sequence modeling toolkit that allows researchers and developers to 
train custom models for translation, summarization, language modeling and other text 
generation tasks.

%package -n     python3-%{pypi_name}
Summary:        %{summary}
%{?python_provide:%python_provide python3-%{pypi_name}}

Requires:       python3dist(bitarray)
Requires:       python3dist(cffi)
Requires:       python3dist(cython)
Requires:       python3dist(hydra-core) >= 1.0.7
Requires:       python3dist(numpy)
Requires:       python3dist(omegaconf)
Requires:       python3dist(regex)
Requires:       python3dist(sacrebleu) >= 1.4.12
Requires:       python3dist(setuptools)
Requires:       python3dist(torch)
Requires:       python3dist(torchaudio) >= 0.8
Requires:       python3dist(tqdm)
Requires:       python3dist(tensorboardx)
%description -n python3-%{pypi_name}
Fairseq is a sequence modeling toolkit that allows researchers and developers to 
train custom models for translation, summarization, language modeling and other text 
generation tasks.

%prep
%autosetup -n %{pypi_name}-%{pypi_version}
sed -i '/omegaconf/d' setup.py
sed -i '/hydra-core/d' setup.py
sed -i 's|/usr/bin/env python|/usr/bin/env python3|g' examples/discriminative_reranking_nmt/scripts/*.py
# Remove bundled egg-info
rm -rf %{pypi_name}.egg-info
%generate_buildrequires
%pyproject_buildrequires

%build
%pyproject_wheel

%install
%pyproject_install

%files -n python3-%{pypi_name}
%license LICENSE
%doc README.md
%{_bindir}/fairseq-eval-lm
%{_bindir}/fairseq-generate
%{_bindir}/fairseq-hydra-train
%{_bindir}/fairseq-interactive
%{_bindir}/fairseq-preprocess
%{_bindir}/fairseq-score
%{_bindir}/fairseq-train
%{_bindir}/fairseq-validate
%{python3_sitearch}/*

%changelog
* Fri Jan 26 2024 zhongling.h <zhonglingh@linux.alibaba.com> - 0.12.2-1
- Initial package.